﻿@model MvcSiteMapProvider.Web.Html.Models.MenuHelperModel
@using System.Web.Mvc.Html
@using MvcSiteMapProvider.Web.Html.Models
@using Microsoft.AspNet.Identity
@using HOD.Models
@using HOD.Managers
@using HOD.Entities


@helper  TopMenu(List<SiteMapNodeModel> nodeList)
{
    UserProfile user = null;
    using (UsersContext db = new UsersContext())
    {
        if (WebSecurity.Initialized)
        {
            user = db.UserProfiles.Find(WebSecurity.CurrentUserId);
        }
    }
    
    @:<div class="navbar"><div class="navbar-inner"><ul class="nav">
    foreach (SiteMapNodeModel node in nodeList)
    {
        string url = node.IsClickable ? node.Url : "#";

        if (!node.Children.Any())
        {
            @:<li><a href="@url">@node.Title</a></li>
        }
        else
        {
            @:<li class="dropdown"><a class="dropdown-toggle" data-toggle="dropdown" href="@url">@node.Title <b class="caret"></b></a>@DropDownMenu(node.Children)</li>
        }

        if (node != nodeList.Last())
        {
                @:<li class="divider-vertical"></li>
            }
    }

    @:</ul>
        if (Request.IsAuthenticated && WebSecurity.Initialized)
        {
            using (Html.BeginForm("LogOff", "Account", FormMethod.Post, new { id = "logoutForm", @class = "navbar-right" }))
            {
            @Html.AntiForgeryToken()

            <ul class="nav navbar-right">
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown">Hello @user.FirstName ! <b class="caret"></b></a>
                    <ul class="dropdown-menu">
                        <li>@Html.ActionLink("Manage Account", "Manage", "Account", routeValues: null, htmlAttributes: new { @class = "username", title = "Manage" })</li>
                        <li> @Messages(user)</li>
                        </ul>
                 </li>
                <li><a href="javascript:document.getElementById('logoutForm').submit()">Log off</a></li>
            </ul>
            }
        }
        else
        {
            <ul class="nav navbar-right">
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown">Register <b class="caret"></b></a>
                    <ul class="dropdown-menu">
                        <li>@Html.ActionLink("Buyer", "Register2", "Account", new { UserType = "Buyer" }, htmlAttributes: new { id = "registerLink" })</li>
                        <li>@Html.ActionLink("Seller", "Register2", "Account", new { UserType = "Seller" }, htmlAttributes: new { id = "registerLink2" })</li>
                        </ul>
                    <li>@Html.ActionLink("Log in", "Login", "Account", routeValues: null, htmlAttributes: new { id = "loginLink" })</li>
                </li>
            </ul>
        }
        @:</div></div>
}

@helper DropDownMenu(SiteMapNodeModelList nodeList)
{
    <ul class="dropdown-menu">

        @foreach (SiteMapNodeModel node in nodeList)
        {
            if (node.Title == "Separator")
            {
            @:<li class="divider"></li>
                continue;
            }

            string url = node.IsClickable ? node.Url : "#";

            if (!node.Children.Any())
            {
            @:<li><a href="@url">@node.Title</a></li>
            }
            else
            {
            @:<li class="dropdown-submenu"><a href="@url">@node.Title</a>@DropDownMenu(node.Children)</li>
            }
        }
    </ul>
}

@TopMenu(Model.Nodes)

@helper Messages(UserProfile user)
{
    if (user != null)
    {
        IMessageManager messageManager = new MessageManager();
        List<Message> messages = messageManager.GetMessagesForUser(user.UserId, false);

        if (messages != null && messages.Count > 0)
        {
           <a href="@Url.Action("Conversations", "UserMessages", new { id = user.UserId})"><span class="badge badge-important">@messages.Count</span> Messages </a>
        }
    }
    
}
